]> arthur.barton.de Git - ngircd-alex.git/blobdiff - src/testsuite/stress-server.sh
ngIRCd Release 27
[ngircd-alex.git] / src / testsuite / stress-server.sh
index f978f4b8c7a3c2b9cd4ddf890a93458f81853492..a9ef50763919fe7c3635a687b53a0b7f9c8f8ae1 100755 (executable)
@@ -1,44 +1,88 @@
 #!/bin/sh
+#
 # ngIRCd Test Suite
-# $Id: stress-server.sh,v 1.1 2002/09/09 22:56:07 alex Exp $
+# Copyright (c)2001-2024 Alexander Barton (alex@barton.de) and Contributors.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+# Please read the file COPYING, README and AUTHORS for more information.
+#
 
-CLIENTS=50
+# parse command line
+[ "$1" -gt 0 ] 2>/dev/null && CLIENTS="$1" || CLIENTS=5
+[ "$2" -gt 0 ] 2>/dev/null && MAX="$2" || MAX=-1
 
-name=`basename $0`
-test=`echo ${name} | cut -d '.' -f 1`
-mkdir -p logs tests
+# detect source directory
+[ -z "$srcdir" ] && srcdir=`dirname "$0"`
+set -u
 
-type expect > /dev/null 2>&1
+# get our name
+name=`basename "$0"`
+
+# create directories
+[ -d logs ] || mkdir logs
+[ -d tests ] || mkdir tests
+
+# test for required external tools
+type expect >/dev/null 2>&1
 if [ $? -ne 0 ]; then
-  echo "SKIP: ${name} -- \"expect\" not found.";  exit 77
+       echo "${name}: \"expect\" not found."
+       exit 77
 fi
-type telnet > /dev/null 2>&1
+type telnet >/dev/null 2>&1
 if [ $? -ne 0 ]; then
-  echo "SKIP: ${name} -- \"telnet\" not found.";  exit 77
+       echo "${name}: \"telnet\" not found.";
+       exit 77
 fi
 
-echo "      stressing server with $CLIENTS clients (be patient!) ..."
+# hello world! :-)
+echo "stressing server with $CLIENTS clients (be patient!):"
+
+# read in functions
+. "${srcdir}/functions.inc"
+
+# create scripts for expect(1)
 no=0
 while [ ${no} -lt $CLIENTS ]; do
-  cat stress-A.e > tests/${no}.e
-  echo "send \"nick test${no}\\r\"" >> tests/${no}.e
-  cat stress-B.e >> tests/${no}.e
-  no=`expr ${no} + 1`
+       cat "${srcdir}/stress-A.e" >tests/${no}.e
+       echo "send \"nick test${no}\\r\"" >>tests/${no}.e
+       cat "${srcdir}/stress-B.e" >>tests/${no}.e
+       no=`expr ${no} + 1`
 done
+
+# run first script and check if it succeeds
+echo_n "checking stress script ..."
+expect tests/0.e >logs/stress-0.log 2>/dev/null
+if [ $? -ne 0 ]; then
+       echo " failure!"
+       exit 1
+else
+       echo " ok."
+fi
+
 no=0
 while [ ${no} -lt $CLIENTS ]; do
-  expect tests/${no}.e > logs/stress-${no}.log 2> /dev/null &
-  no=`expr ${no} + 1`
+       expect tests/${no}.e >logs/stress-${no}.log 2>/dev/null &
+
+       no=`expr ${no} + 1`
+       echo "started client $no/$CLIENTS."
+
+       [ $MAX -gt 0 ] && "$srcdir/wait-tests.sh" $MAX
 done
 
+echo_n "waiting for clients to complete: ."
 touch logs/check-idle.log
 while true; do
-  expect check-idle.e >> logs/check-idle.log
-  res=$?
-  [ $res -eq 0 ] && exit 0
-  [ $res -eq 1 ] && exit 1
-  sleep 1
-  echo "====================" >> logs/check-idle.log
+       expect "${srcdir}/check-idle.e" >>logs/check-idle.log; res=$?
+       echo "====================" >>logs/check-idle.log
+       [ $res -ne 99 ] && break
+
+       # there are still clients connected. Wait ...
+       sleep 3
+       echo_n "."
 done
 
-# -eof-
+[ $res -eq 0 ] && echo " ok." || echo " failure!"
+exit $res